require 'spec_helper'

describe Patriarch::TransactionStep do
  
  let(:monster)         { Monster.create }
  let(:fallen_angel)    { FallenAngel.create }
  let(:love_letter)     { LoveLetter.create }
  let(:transaction_step){ Patriarch::TransactionStep.new(:pick_up,monster,fallen_angel,love_letter)  }

  it "#actor returns the actor instance" do
    transaction_step.actor.should == monster 
  end

  it "#medium returns the medium instance" do
    transaction_step.medium.should == love_letter 
  end

  it "#target returns the target instance" do
    transaction_step.target.should == fallen_angel 
  end 

  it "#add_to_queue appends proc to queue" do 
    p = Proc.new { p "do_nothing"}
    q = Proc.new { p "do_nothing"}
    transaction_step.add_to_queue p
    transaction_step.add_to_queue q
    transaction_step.queue.should == [p,q]
  end
end
